NX Open C++ Reference Guide
Public Types | Public Member Functions | List of all members
NXOpen::Features::ShipDesign::EdgeCutBuilder Class Reference

Represents a NXOpen::Features::ShipDesign::EdgeCut builder. More...

Inheritance diagram for NXOpen::Features::ShipDesign::EdgeCutBuilder:
NXOpen::Features::FeatureBuilder NXOpen::Builder NXOpen::TaggedObject NXOpen::GeometricUtilities::IComponentBuilder

Public Types

enum  ArraySpacing { ArraySpacingEvenDistribution, ArraySpacingCustomDefined }
 available methods used to define the spacing between the cuts More...
 
enum  VersionID { VersionIDNx85, VersionIDNx901 }
 version identifiers for the different revisions of the edge cut feature. More...
 

Public Member Functions

int CutCount ()
 Returns the number of cuts
Created in NX8.5.0. More...
 
NXOpen::ExpressionCutOrientationAngle ()
 Returns the cut orientation angle. More...
 
NXOpen::GeometricUtilities::OnPathDimensionBuilderEndPositionOnGuide ()
 Returns the offset from the end of the guide curve (or end trim object) where cut placement will end. More...
 
NXOpen::SectionGuideCurve ()
 Returns the guide curve used to place the cuts (may be made up of edges or curves). More...
 
NXOpen::ExpressionGuideOffset ()
 Returns the guide offset (how far away to place the cuts from the guide curve)
Created in NX8.5.0. More...
 
NXOpen::DirectionHorizontalReference ()
 Returns the horizontal reference. More...
 
NXOpen::Features::ShipDesign::ManufacturingStockBuilderManufacturingInformation ()
 Returns the manufacturing stock builder that holds the manufacturing data. More...
 
NXOpen::SelectTaggedObjectListPathGeometry ()
 Returns the path geometry. More...
 
bool PathReverseDirection ()
 Returns the path reverse direction flag. More...
 
NXOpen::SelectDisplayableObjectListPlacementGeometry ()
 Returns the placement geometry. More...
 
NXOpen::Vector3d ReferenceDirection ()
 Returns the reference direction
Created in NX9.0.1. More...
 
NXOpen::Point3d ReferencePoint ()
 Returns the reference point (part units)
Created in NX9.0.1. More...
 
NXOpen::SelectNXObjectSelectEndLimit ()
 Returns the select end limit. More...
 
NXOpen::SelectNXObjectSelectStartLimit ()
 Returns the select start limit. More...
 
NXOpen::SelectFaceListSelectTargetFace ()
 Returns the select target face. More...
 
void SetCutCount (int cutCount)
 Sets the number of cuts
Created in NX8.5.0. More...
 
void SetHorizontalReference (NXOpen::Direction *horizontalReference)
 Sets the horizontal reference. More...
 
void SetPathReverseDirection (bool pathReverseDirection)
 Sets the path reverse direction flag. More...
 
void SetReferenceDirection (const NXOpen::Vector3d &referenceDirection)
 Sets the reference direction
Created in NX9.0.1. More...
 
void SetReferencePoint (const NXOpen::Point3d &referencePoint)
 Sets the reference point (part units)
Created in NX9.0.1. More...
 
void SetSpacing (NXOpen::Features::ShipDesign::EdgeCutBuilder::ArraySpacing spacing)
 Sets the spacing (even distribution or custom defined)
Created in NX8.5.0. More...
 
void SetSpacingReference (NXOpen::Direction *spacingReference)
 Sets the spacing reference direction. More...
 
void SetSymmetricOffsets (bool symmetricOffsets)
 Sets the symmetric offsets toggle. More...
 
NXOpen::Features::ShipDesign::SteelFeatureSpreadsheetBuilderSketchBlock ()
 Returns the sketch block. More...
 
NXOpen::ExpressionSpaceBetweenCuts ()
 Returns the distance between each cut. More...
 
NXOpen::Features::ShipDesign::EdgeCutBuilder::ArraySpacing Spacing ()
 Returns the spacing (even distribution or custom defined)
Created in NX8.5.0. More...
 
NXOpen::DirectionSpacingReference ()
 Returns the spacing reference direction. More...
 
NXOpen::GeometricUtilities::OnPathDimensionBuilderStartPositionOnGuide ()
 Returns the offset from the start of the guide curve (or start trim object) where cut placement will begin
Created in NX8.5.0. More...
 
bool SymmetricOffsets ()
 Returns the symmetric offsets toggle. More...
 
NXOpen::Features::ShipDesign::EdgeCutBuilder::VersionID Version ()
 Returns the version of the feature (used to determine which properties and methods are applicable) during edit. More...
 
- Public Member Functions inherited from NXOpen::Features::FeatureBuilder
NXOpen::Features::FeatureCommitFeature ()
 Commits the feature parameters and creates the feature. More...
 
NXOpen::Features::FeatureGetFeature ()
 Returns the feature currently being edited by this builder. More...
 
void HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature)
 Re-suppress an internal parent feature (a slave feature) after it has been edited. More...
 
bool ParentFeatureInternal ()
 Returns whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
bool PatchSolutionFlag ()
 Returns the patch solution flag
Created in NX8.0.1. More...
 
NXString PatchSurfaceFilename ()
 Returns the patch surface filename
Created in NX8.0.1. More...
 
void SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the parent features which would be internal or slaves to the feature being created or commited
Created in NX6.0.0. More...
 
void SetParentFeatureInternal (bool isInternal)
 Sets whether or not the latest timestamped parent feature of this feature should be made internal
Created in NX5.0.0. More...
 
void SetPatchSolutionFlag (bool optionValue)
 Sets the patch solution flag
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const NXString &surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetPatchSurfaceFilename (const char *surfaceFilename)
 Sets the patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename)
 Sets the surrounding patch surface filename
Created in NX8.0.1. More...
 
void ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature)
 Unsuppress an internal parent feature (a slave feature) so it can be edited. More...
 
NXString SurroundingPatchSurfaceFilename ()
 Returns the surrounding patch surface filename
Created in NX8.0.1. More...
 
void UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature)
 Set the internal parent feature of the feature being edited to external
Created in NX6.0.0. More...
 
- Public Member Functions inherited from NXOpen::Builder
NXOpen::NXObjectCommit ()
 Commits any edits that have been applied to the builder. More...
 
void Destroy ()
 Deletes the builder, and cleans up any objects created by the builder. More...
 
std::vector< NXOpen::NXObject * > GetCommittedObjects ()
 For builders that create more than one object, this method returns the objects that are created by commit. More...
 
NXOpen::NXObjectGetObject ()
 Returns the object currently being edited by this builder. More...
 
void ShowResults ()
 Updates the model to reflect the result of an edit to the model for all builders that support showing results. More...
 
virtual bool Validate ()
 Validate whether the inputs to the component are sufficient for commit to be called. More...
 
- Public Member Functions inherited from NXOpen::TaggedObject
tag_t Tag () const
 Returns the tag of this object. More...
 

Detailed Description

Represents a NXOpen::Features::ShipDesign::EdgeCut builder.

The Edge Cut creates a series of cuts with an offset from an edge or curve.
To create a new instance of this class, use NXOpen::Features::ShipCollection::CreateEdgeCutBuilder
Default values.

Property Value

CutCount

0

CutOrientationAngle.Value

0

GuideOffset.Value

50 (millimeters part), 2 (inches part)

SpaceBetweenCuts.Value

50 (millimeters part), 2 (inches part)

Spacing

EvenDistribution

SymmetricOffsets

0


Created in NX8.5.0.

Member Enumeration Documentation

available methods used to define the spacing between the cuts

Enumerator
ArraySpacingEvenDistribution 

Cuts will automatically be spaced evenly along the length of the guide.

ArraySpacingCustomDefined 

The user can specify a custom amount of space between the cuts.

version identifiers for the different revisions of the edge cut feature.

Enumerator
VersionIDNx85 

This feature builder is used to edit an existing NX85 - NX9 edge cut feature.

Use: SelectTargetFace and GuideCurve

VersionIDNx901 

This feature builder is used to create or edit an NX901 or beyond feature.

Use: PlacementGeometry, PathGeometry, ReferencePoint, ReferenceDirection, and if needed PathReverseDirection

Member Function Documentation

int NXOpen::Features::ShipDesign::EdgeCutBuilder::CutCount ( )

Returns the number of cuts
Created in NX8.5.0.



License requirements : None

NXOpen::Expression* NXOpen::Features::ShipDesign::EdgeCutBuilder::CutOrientationAngle ( )

Returns the cut orientation angle.

Typically the x axis of the cut's cross section sketch is parallel to the guide curve, the orientation angle rotates the sketch away from the guide curve
Created in NX8.5.0.

License requirements : None

NXOpen::GeometricUtilities::OnPathDimensionBuilder* NXOpen::Features::ShipDesign::EdgeCutBuilder::EndPositionOnGuide ( )

Returns the offset from the end of the guide curve (or end trim object) where cut placement will end.

Note if the spacing is set to CustomDefined, you won't notice the end trim getting used, unless you try to place too many cuts between along the guide (including any trim objects and offsets added by the Start and End positions on the guide).
Created in NX8.5.0.

License requirements : None

NXOpen::Section* NXOpen::Features::ShipDesign::EdgeCutBuilder::GuideCurve ( )

Returns the guide curve used to place the cuts (may be made up of edges or curves).

NOTE this is only used on features that were created prior to NX901. If editing a feature created in NX9.0.1 or beyond, use the path geometry property instead.
Created in NX8.5.0.

License requirements : None

NXOpen::Expression* NXOpen::Features::ShipDesign::EdgeCutBuilder::GuideOffset ( )

Returns the guide offset (how far away to place the cuts from the guide curve)
Created in NX8.5.0.



License requirements : None

NXOpen::Direction* NXOpen::Features::ShipDesign::EdgeCutBuilder::HorizontalReference ( )

Returns the horizontal reference.

The horizontal reference is optional. It is used to orient the cuts. If null, the guide tangent is used for the orientation reference at each cut.
Created in NX12.0.0.

License requirements : None

NXOpen::Features::ShipDesign::ManufacturingStockBuilder* NXOpen::Features::ShipDesign::EdgeCutBuilder::ManufacturingInformation ( )

Returns the manufacturing stock builder that holds the manufacturing data.


Created in NX8.5.1.

License requirements : None

NXOpen::SelectTaggedObjectList* NXOpen::Features::ShipDesign::EdgeCutBuilder::PathGeometry ( )

Returns the path geometry.

NOTE this is only used on features that were created in NX901 or later. If editing a feature created before NX9.0.1, use the guide curve property instead.
Created in NX9.0.1.

License requirements : None

bool NXOpen::Features::ShipDesign::EdgeCutBuilder::PathReverseDirection ( )

Returns the path reverse direction flag.

NOTE this is only used on features that were created in NX901 or later.
Created in NX9.0.1.

License requirements : None

NXOpen::SelectDisplayableObjectList* NXOpen::Features::ShipDesign::EdgeCutBuilder::PlacementGeometry ( )

Returns the placement geometry.

NOTE this is only used on features that were created in NX901 or later. If editing a feature created before NX9.0.1, use the select target face property instead.
Created in NX9.0.1.

License requirements : None

NXOpen::Vector3d NXOpen::Features::ShipDesign::EdgeCutBuilder::ReferenceDirection ( )

Returns the reference direction
Created in NX9.0.1.



License requirements : None

NXOpen::Point3d NXOpen::Features::ShipDesign::EdgeCutBuilder::ReferencePoint ( )

Returns the reference point (part units)
Created in NX9.0.1.



License requirements : None

NXOpen::SelectNXObject* NXOpen::Features::ShipDesign::EdgeCutBuilder::SelectEndLimit ( )

Returns the select end limit.

The end limit is used to trim the end of the guide curve. Note if the spacing is set to CustomDefined, you won't notice the end trim getting used, unless you try to place too many cuts between the start and end trim (including any offsets added by the Start and End positions on the guide). NOTE features created before NX9.0.1 could use solid edges, lines, circles, splines, spcurves, datum planes, and planar faces as a limit object. Any feature created in NX9.0.1 or beyond can use any of those limit objects as well as non-planar faces.
Created in NX8.5.0.

License requirements : None

NXOpen::SelectNXObject* NXOpen::Features::ShipDesign::EdgeCutBuilder::SelectStartLimit ( )

Returns the select start limit.

The start limit is used to trim the start of the guide curve. NOTE features created before NX9.0.1 could use solid edges, lines, circles, splines, spcurves, datum planes, and planar faces as a limit object. Any feature created in NX9.0.1 or beyond can use any of those limit objects as well as non-planar faces.
Created in NX8.5.0.

License requirements : None

NXOpen::SelectFaceList* NXOpen::Features::ShipDesign::EdgeCutBuilder::SelectTargetFace ( )

Returns the select target face.

NOTE this is only used on features that were created prior to NX901. If editing a feature created in NX9.0.1 or beyond, use the placement geometry property instead.
Created in NX8.5.0.

License requirements : None

void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetCutCount ( int  cutCount)

Sets the number of cuts
Created in NX8.5.0.



License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
cutCountcutcount
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetHorizontalReference ( NXOpen::Direction horizontalReference)

Sets the horizontal reference.

The horizontal reference is optional. It is used to orient the cuts. If null, the guide tangent is used for the orientation reference at each cut.
Created in NX12.0.0.

License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
horizontalReferencehorizontalreference
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetPathReverseDirection ( bool  pathReverseDirection)

Sets the path reverse direction flag.

NOTE this is only used on features that were created in NX901 or later.
Created in NX9.0.1.

License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
pathReverseDirectionpathreversedirection
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetReferenceDirection ( const NXOpen::Vector3d referenceDirection)

Sets the reference direction
Created in NX9.0.1.



License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
referenceDirectionreferencedirection
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetReferencePoint ( const NXOpen::Point3d referencePoint)

Sets the reference point (part units)
Created in NX9.0.1.



License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
referencePointreferencepoint
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetSpacing ( NXOpen::Features::ShipDesign::EdgeCutBuilder::ArraySpacing  spacing)

Sets the spacing (even distribution or custom defined)
Created in NX8.5.0.



License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
spacingspacing
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetSpacingReference ( NXOpen::Direction spacingReference)

Sets the spacing reference direction.

The spacing reference direction is optional. It is used to measure the space between cuts in a linear distance. If null, the spacing is measured via arc length along the guide.
Created in NX12.0.0.

License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
spacingReferencespacingreference
void NXOpen::Features::ShipDesign::EdgeCutBuilder::SetSymmetricOffsets ( bool  symmetricOffsets)

Sets the symmetric offsets toggle.

Note this is ignored if spacing is set to custom defined. When symmetric offsets are used, the length of the guide is divided by the number of cuts to define the space between cuts, and half of the distance between each cut is applied as a start and end offset along the guide.
Created in NX8.5.0.

License requirements : nx_ship_detail ("Ship Detail Design")

Parameters
symmetricOffsetssymmetricoffsets
NXOpen::Features::ShipDesign::SteelFeatureSpreadsheetBuilder* NXOpen::Features::ShipDesign::EdgeCutBuilder::SketchBlock ( )

Returns the sketch block.


Users can specify the hole shape using a single sketch. The sketch type and its parameters are controlled by the NXOpen::Features::ShipDesign::SteelFeatureSpreadsheetBuilder .


Created in NX8.5.0.

License requirements : None

NXOpen::Expression* NXOpen::Features::ShipDesign::EdgeCutBuilder::SpaceBetweenCuts ( )

Returns the distance between each cut.

Note this is ignored if spacing is set to equal spacing.
Created in NX8.5.0.

License requirements : None

NXOpen::Features::ShipDesign::EdgeCutBuilder::ArraySpacing NXOpen::Features::ShipDesign::EdgeCutBuilder::Spacing ( )

Returns the spacing (even distribution or custom defined)
Created in NX8.5.0.



License requirements : None

NXOpen::Direction* NXOpen::Features::ShipDesign::EdgeCutBuilder::SpacingReference ( )

Returns the spacing reference direction.

The spacing reference direction is optional. It is used to measure the space between cuts in a linear distance. If null, the spacing is measured via arc length along the guide.
Created in NX12.0.0.

License requirements : None

NXOpen::GeometricUtilities::OnPathDimensionBuilder* NXOpen::Features::ShipDesign::EdgeCutBuilder::StartPositionOnGuide ( )

Returns the offset from the start of the guide curve (or start trim object) where cut placement will begin
Created in NX8.5.0.



License requirements : None

bool NXOpen::Features::ShipDesign::EdgeCutBuilder::SymmetricOffsets ( )

Returns the symmetric offsets toggle.

Note this is ignored if spacing is set to custom defined. When symmetric offsets are used, the length of the guide is divided by the number of cuts to define the space between cuts, and half of the distance between each cut is applied as a start and end offset along the guide.
Created in NX8.5.0.

License requirements : None

NXOpen::Features::ShipDesign::EdgeCutBuilder::VersionID NXOpen::Features::ShipDesign::EdgeCutBuilder::Version ( )

Returns the version of the feature (used to determine which properties and methods are applicable) during edit.

The version of new features during create will be NX901
Created in NX9.0.1.

License requirements : None


The documentation for this class was generated from the following file:
Copyright 2017 Siemens Product Lifecycle Management Software Inc. All Rights Reserved.